#include <stdio.h>
#include <stdlib.h>

struct node{
  char *name;
  struct node *child;
  struct node *brother;
};

typedef struct node node;

node *conNode(char *name)
{
  node *ret = (node *)malloc(sizeof(node));
  ret->name = name;
  ret->child = 0;
  ret->brother = 0; 
  return ret;
}

node *conTree2(char *name, node *node1, node *node2)
{
  node *root = (node *)malloc(sizeof(node));
  /* Set root */
  root->name = name;
  root->child = node1;
  root->brother = 0;

  /* Set children */
  node1->brother = node2;

  return root;
}

node *conTree3(char *name, node *node1, node *node2, node *node3)
{
  node *root = (node *)malloc(sizeof(node));
  /* Set root */
  root->name = name;
  root->child = node1;
  root->brother = 0;

  /* Set children */
  node1->brother = node2;
  node2->brother = node3;

  return root;
}

void traverseTree(node *root, int layer)
{
  int i = 0;
  for( ; i<layer ; i++)
    printf("   ");

  node *children = root->child;
  if(children) printf("+");
  else printf("-");
  printf("%s\n", root->name);

  
  while(children)
  {
    traverseTree(children, layer+1);
    children = children->brother;
  }
}


